package at.ac.uibk.gitsearch.service.dto;

import at.ac.uibk.gitsearch.domain.enumeration.ReviewStatus;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * A DTO for the {@link at.ac.uibk.gitsearch.domain.ReviewHistoryEntry} entity.
 */
public class ReviewHistoryEntryDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    @Size(max = 255)
    private String message;

    @NotNull
    private ReviewStatus type;

    @NotNull
    private Instant entryDate;

    private Long review;

    private Long reviewRating;

    private Long user;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public ReviewStatus getType() {
        return type;
    }

    public void setType(ReviewStatus type) {
        this.type = type;
    }

    public Instant getEntryDate() {
        return entryDate;
    }

    public void setEntryDate(Instant entryDate) {
        this.entryDate = entryDate;
    }

    public Long getReview() {
        return review;
    }

    public void setReview(Long review) {
        this.review = review;
    }

    public Long getReviewRating() {
        return reviewRating;
    }

    public void setReviewRating(Long reviewRating) {
        this.reviewRating = reviewRating;
    }

    public Long getUser() {
        return user;
    }

    public void setUser(Long user) {
        this.user = user;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof ReviewHistoryEntryDTO)) {
            return false;
        }

        if (this.id == null) {
            return false;
        }
        ReviewHistoryEntryDTO reviewHistoryEntryDTO = (ReviewHistoryEntryDTO) o;
        return Objects.equals(this.id, reviewHistoryEntryDTO.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.id);
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "ReviewHistoryEntryDTO{" +
            "id=" + getId() +
            ", message='" + getMessage() + "'" +
            ", type='" + getType() + "'" +
            ", entryDate='" + getEntryDate() + "'" +
            ", review=" + getReview() +
            ", reviewRating=" + getReviewRating() +
            ", user=" + getUser() +
            "}";
    }
}
