import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { ChatMessageDTO } from './chat.model';

@Injectable({
  providedIn: 'root',
})
export class ChatMessageService {
  private baseUrl = '/api/chatmessages';

  constructor(private http: HttpClient) {}

  getAllChatMessages(): Observable<any> {
    return this.http.get(`${this.baseUrl}`);
  }

  getChatMessageById(id: number): Observable<any> {
    return this.http.get(`${this.baseUrl}/${id}`);
  }

  saveChatMessage(chatMessage: ChatMessageDTO): Observable<any> {
    return this.http.post(`${this.baseUrl}`, chatMessage);
  }

  deleteChatMessage(id: number): Observable<any> {
    return this.http.delete(`${this.baseUrl}/${id}`);
  }

  findByReview(reviewId: number): Observable<any> {
    return this.http.get(`${this.baseUrl}/review/${reviewId}`);
  }

  findByReviewOrderByTimestampAsc(reviewId: number): Observable<any> {
    return this.http.get(`${this.baseUrl}/review/${reviewId}/ordered`);
  }
}
