import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { OAuth2Config } from './oauth2-config.model';
import { Observable } from 'rxjs';
import { ApplicationConfigService } from 'app/core/config/application-config.service';

@Injectable({
  providedIn: 'root',
})
export class OAuth2ConfigService {
  constructor(private http: HttpClient, private applicationConfigService: ApplicationConfigService) {}

  get(clientId: string): Observable<OAuth2Config> {
    return this.http.get<OAuth2Config>(this.applicationConfigService.getEndpointFor('oauth2/oauth2Config') + `/${clientId}`);
  }

  getAllConfigs(): Observable<OAuth2Config[]> {
    return this.http.get<OAuth2Config[]>(this.applicationConfigService.getEndpointFor('oauth2Config/allConfigs'));
  }
}
